"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = MUIDatatable;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _core = require("@material-ui/core");

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

var _Table = _interopRequireDefault(require("@material-ui/core/Table"));

var _TableHead = _interopRequireDefault(require("@material-ui/core/TableHead"));

var _TableRow = _interopRequireDefault(require("@material-ui/core/TableRow"));

var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));

var _TableBody = _interopRequireDefault(require("@material-ui/core/TableBody"));

var _Chip = _interopRequireDefault(require("@material-ui/core/Chip"));

var _TextField = _interopRequireDefault(require("@material-ui/core/TextField"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Search = _interopRequireDefault(require("@material-ui/icons/Search"));

var _Save = _interopRequireDefault(require("@material-ui/icons/Save"));

var _Close = _interopRequireDefault(require("@material-ui/icons/Close"));

var _FilterList = _interopRequireDefault(require("@material-ui/icons/FilterList"));

var _ViewColumn = _interopRequireDefault(require("@material-ui/icons/ViewColumn"));

var _Menu = _interopRequireDefault(require("@material-ui/core/Menu"));

var _FormControl = _interopRequireDefault(require("@material-ui/core/FormControl"));

var _FormLabel = _interopRequireDefault(require("@material-ui/core/FormLabel"));

var _FormGroup = _interopRequireDefault(require("@material-ui/core/FormGroup"));

var _FormControlLabel = _interopRequireDefault(require("@material-ui/core/FormControlLabel"));

var _Checkbox = _interopRequireDefault(require("@material-ui/core/Checkbox"));

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _InputLabel = _interopRequireDefault(require("@material-ui/core/InputLabel"));

var _MenuItem = _interopRequireDefault(require("@material-ui/core/MenuItem"));

var _TablePagination = _interopRequireDefault(require("@material-ui/core/TablePagination"));

var _reactCsv = require("react-csv");

var _TableHeadButton = _interopRequireDefault(require("./components/TableHeadButton"));

var _MUITableRow = _interopRequireDefault(require("./components/MUITableRow"));

var _reactLoadingSkeleton = _interopRequireDefault(require("react-loading-skeleton"));

var _MUITableFooterCell = _interopRequireDefault(require("./components/MUITableFooterCell"));

var _InputAdornment = _interopRequireDefault(require("@material-ui/core/InputAdornment"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    root: {
      width: '100%',
      overflow: 'hide'
    },
    tableContainer: {
      overflowX: 'scroll'
    },
    table: {// minWidth: 650,
    },
    tableRowClick: {
      '&:hover': {
        cursor: 'pointer',
        backgroundColor: '#eaeaea'
      },
      '&:active': {
        backgroundColor: '#dadada'
      }
    },
    tableCellNoWrap: {
      whiteSpace: 'nowrap'
    }
  };
});
var defaultOptions = {
  fillEmptyRows: false,
  rowsPerPage: 10,
  csvExport: true,
  initialSorts: [],
  initialFilters: [],
  onRowClick: null,
  maxRowHeight: null,
  footerRow: false,
  selectedRowId: null,
  loading: false
};
var defaultColumnValues = {
  visible: true,
  sortable: true,
  hideable: true,
  filterable: true,
  filterMatch: 'exact',
  noWrap: true,
  minWidth: 0,
  padding: {
    top: 14,
    right: 40,
    bottom: 14,
    left: 16
  }
};
MUIDatatable.defaultProps = {
  data: [],
  columns: [],
  options: {},
  title: '',
  buttons: [],
  filtersRef: function filtersRef() {},
  sortsRef: function sortsRef() {},
  filteredDataRef: function filteredDataRef() {}
};

var mapObject = function mapObject(source, destination) {
  if (source == null) {
    return destination;
  }

  if (destination == null) {
    return source;
  }

  return _objectSpread({}, destination, {}, source);
};

function MUIDatatable(_ref) {
  var dataInput = _ref.data,
      optionsInput = _ref.options,
      columnsInput = _ref.columns,
      title = _ref.title,
      buttons = _ref.buttons,
      filtersRef = _ref.filtersRef,
      sortsRef = _ref.sortsRef,
      filteredDataRef = _ref.filteredDataRef;
  var classes = useStyles();
  var options = (0, _react.useMemo)(function () {
    return mapObject(optionsInput, defaultOptions);
  }, [optionsInput]); //console.log('options', options);

  var _useState = (0, _react.useState)(defaultOptions.rowsPerPage),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      rowsPerPage = _useState2[0],
      setRowsPerPage = _useState2[1];

  (0, _react.useEffect)(function () {
    setRowsPerPage(options.rowsPerPage);
  }, [options.rowsPerPage]);
  var columns = (0, _react.useMemo)(function () {
    columnsInput.forEach(function (column) {
      if (typeof column.padding === 'number') {
        column.padding = {
          top: column.padding,
          right: column.padding,
          bottom: column.padding,
          left: column.padding
        };
      }
    });
    return (0, _toConsumableArray2["default"])(columnsInput.map(function (column, index) {
      return _objectSpread({
        id: index
      }, mapObject(column, defaultColumnValues));
    }));
  }, [columnsInput]);

  var getColumn = function getColumn(columnId) {
    return columns.find(function (x) {
      return x.id === columnId;
    });
  };

  var _useState3 = (0, _react.useState)([]),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      data = _useState4[0],
      setData = _useState4[1];

  (0, _react.useEffect)(function () {
    return setData((0, _toConsumableArray2["default"])(dataInput));
  }, [dataInput]);
  /*  Sorting  */

  var _useState5 = (0, _react.useState)([]),
      _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
      sorts = _useState6[0],
      setSorts = _useState6[1];

  (0, _react.useEffect)(function () {
    setSorts((0, _toConsumableArray2["default"])(options.initialSorts));
  }, [options.initialSorts]);

  var addSort = function addSort(columnId, direction) {
    var clear = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    setSorts(function (prev) {
      if (!direction) return (0, _toConsumableArray2["default"])(prev.filter(function (x) {
        return x.columnId !== columnId;
      }));
      if (clear) prev = prev.filter(function (x) {
        return x.columnId === columnId;
      });
      var index = prev.findIndex(function (x) {
        return x.columnId === columnId;
      });

      if (index > -1) {
        prev[index].direction = direction;
      } else {
        prev.push({
          columnId: columnId,
          direction: direction
        });
      }

      return (0, _toConsumableArray2["default"])(prev);
    });
  };

  var sortColumn = function sortColumn(event, columnId) {
    var sortColumn = sorts.find(function (x) {
      return x.columnId === columnId;
    });
    var direction = 'asc';

    if (sortColumn) {
      if (sortColumn.direction === 'asc') {
        direction = 'desc';
      } else if (event.shiftKey) {
        direction = null;
      }
    }

    addSort(columnId, direction, !event.shiftKey);
  };

  var colValue = function colValue(row, columnId) {
    var c = getColumn(columnId);
    return typeof c.Cell === 'function' && c.Cell(row[c.accessor], row) || row[c.accessor];
  };

  var sortValue = function sortValue(row, columnId) {
    var c = getColumn(columnId);
    return typeof c.sortValue === 'function' && c.sortValue(row[c.accessor], row) || row[c.accessor] || colValue(row, columnId);
  };

  var compareItems = function compareItems(a, b, sortColumn) {
    var aValue = sortValue(a, sortColumn.columnId);
    var bValue = sortValue(b, sortColumn.columnId);

    if (typeof getColumn(sortColumn.columnId).sort === 'function') {
      return getColumn(sortColumn.columnId).sort(a, b, sortColumn.direction);
    } else if (typeof aValue === 'number') {
      return sortColumn.direction === 'desc' ? bValue - aValue : aValue - bValue;
    } else {
      return sortColumn.direction === 'desc' ? String(bValue).localeCompare(aValue) : String(aValue).localeCompare(bValue);
    }
  };

  sorts.slice().reverse().forEach(function (sortColumn) {
    data.sort(function (a, b) {
      return compareItems(a, b, sortColumn);
    });
  });
  /*  Column Visibility  */

  var _useState7 = (0, _react.useState)({}),
      _useState8 = (0, _slicedToArray2["default"])(_useState7, 2),
      toggledColumns = _useState8[0],
      setToggledColumns = _useState8[1];

  (0, _react.useEffect)(function () {
    setToggledColumns(function (prev) {
      return _objectSpread({}, columns.reduce(function (toggled, column) {
        toggled[column.id] = column.visible;
        return toggled;
      }, {}), {}, prev);
    });
  }, [columnsInput]);

  var handleToggleColumnVisible = function handleToggleColumnVisible(columnId) {
    setToggledColumns(function (prev) {
      return _objectSpread({}, prev, (0, _defineProperty2["default"])({}, columnId, !prev[columnId]));
    });
  };

  var visibleColumns = (0, _react.useMemo)(function () {
    return columns.filter(function (column) {
      return toggledColumns[column.id];
    });
  }, [columns, toggledColumns]);
  /*  Search Filtering  */

  var _useState9 = (0, _react.useState)([]),
      _useState10 = (0, _slicedToArray2["default"])(_useState9, 2),
      filters = _useState10[0],
      setFilters = _useState10[1];

  (0, _react.useEffect)(function () {
    setFilters((0, _toConsumableArray2["default"])(options.initialFilters));
  }, [options.initialFilters]);

  var addFilter = function addFilter(value) {
    var columnId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : -1;
    var type = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'default';
    setFilters(function (prev) {
      prev = prev.filter(function (x) {
        return x.columnId !== columnId;
      });
      if (!!value && value !== '') prev.push({
        value: value,
        columnId: columnId,
        type: type
      });
      return (0, _toConsumableArray2["default"])(prev);
    });
    setCurrentPage(0);
  };

  var removeFilter = function removeFilter(filterId) {
    setFilters(function (prev) {
      prev.splice(filterId, 1);
      return (0, _toConsumableArray2["default"])(prev);
    });
  };

  var filterValue = function filterValue(row, columnId) {
    var c = getColumn(columnId);
    return typeof c.filterValue === 'function' && c.filterValue(row[c.accessor], row) || row[c.accessor] || colValue(row, columnId);
  };

  var filterMenuItem = function filterMenuItem(row, columnId) {
    var c = getColumn(columnId);
    return typeof c.filterMenuItem === 'function' && c.filterMenuItem(row[c.accessor], row) || colValue(row, columnId);
  };

  var filterFn = function filterFn(data, filter) {
    if (filter.value == null || filter.value === '') return data;
    if (filter.type === 'exact') return data.filter(function (x) {
      return String(filterValue(x, filter.columnId)) === String(filter.value);
    });
    if (filter.type === 'lt') return data.filter(function (x) {
      return filterValue(x, filter.columnId) < filter.value;
    });
    if (filter.type === 'lte') return data.filter(function (x) {
      return filterValue(x, filter.columnId) <= filter.value;
    });
    if (filter.type === 'gt') return data.filter(function (x) {
      return filterValue(x, filter.columnId) > filter.value;
    });
    if (filter.type === 'gte') return data.filter(function (x) {
      return filterValue(x, filter.columnId) >= filter.value;
    });
    return data.filter(function (x) {
      return String(filterValue(x, filter.columnId)).toLowerCase().includes(String(filter.value).toLowerCase());
    });
  };

  var filteredData = (0, _react.useMemo)(function () {
    var tempData = (0, _toConsumableArray2["default"])(data);
    filters.forEach(function (filter) {
      if (filter.columnId === -1) {
        tempData = tempData.filter(function (row) {
          return visibleColumns.reduce(function (acc, column) {
            return acc || String(colValue(row, column.id)).toLowerCase().includes(String(filter.value).toLowerCase());
          }, false);
        });
      } else {
        tempData = filterFn(data, filter);
      }
    }); //console.log('generate filteredData rows: ' + tempData.length);

    return tempData;
  }, [data, filters, columnsInput, toggledColumns, sorts]);

  var _useState11 = (0, _react.useState)(false),
      _useState12 = (0, _slicedToArray2["default"])(_useState11, 2),
      showSearch = _useState12[0],
      setShowSearch = _useState12[1];

  var searchTerm = (filters.find(function (x) {
    return x.columnId === -1;
  }) || {}).value || '';
  var searchFieldRef = (0, _react.useRef)();

  var handleToggleSearch = function handleToggleSearch() {
    setShowSearch(function (prev) {
      if (!prev) searchFieldRef.current.focus();
      return !prev;
    });
  };
  /*  Refs  */


  (0, _react.useEffect)(function () {
    return filtersRef(filters);
  }, [filters]);
  (0, _react.useEffect)(function () {
    return sortsRef(sorts);
  }, [sorts]);
  (0, _react.useEffect)(function () {
    return filteredDataRef(filteredData);
  }, [filteredData]);
  /*  Pagination  */

  var _useState13 = (0, _react.useState)(0),
      _useState14 = (0, _slicedToArray2["default"])(_useState13, 2),
      currentPage = _useState14[0],
      setCurrentPage = _useState14[1];

  var pageData = filteredData.slice(currentPage * rowsPerPage, (currentPage + 1) * rowsPerPage);
  var emptyRows = new Array(Math.max(0, rowsPerPage - pageData.length)).fill(0);
  /*  CSV Download  */

  var csvValue = function csvValue(row, columnId) {
    var c = getColumn(columnId);
    return typeof c.csvValue === 'function' && c.csvValue(row[c.accessor], row) || row[c.accessor] || colValue(row, columnId);
  };

  var generateCsvData = function generateCsvData() {
    if (!filteredData) return [[]];
    var headers = visibleColumns.map(function (column) {
      return column.csvHeader || column.title;
    });
    var csvData = [headers].concat((0, _toConsumableArray2["default"])(filteredData.map(function (row) {
      return visibleColumns.map(function (column) {
        return csvValue(row, column.id);
      });
    })));
    return csvData;
  };
  /* Row Click */


  var handleOnRowClick = function handleOnRowClick(event, row) {
    if (typeof options.onRowClick === 'function') {
      options.onRowClick(row, event);
    }
  };
  /*  Rendering  */
  //console.log('render');


  return _react["default"].createElement(_Paper["default"], {
    className: classes.root
  }, _react["default"].createElement("div", {
    style: {
      padding: 16
    }
  }, _react["default"].createElement("div", {
    style: {
      display: 'flex'
    }
  }, _react["default"].createElement(TitleSearchBar, {
    title: title,
    showSearch: showSearch,
    setShowSearch: setShowSearch,
    searchFieldRef: searchFieldRef,
    searchTerm: searchTerm,
    addFilter: addFilter
  }), _react["default"].createElement("div", {
    style: {
      flex: 1
    }
  }), _react["default"].createElement("div", {
    style: {
      flex: -1,
      display: 'flex',
      flexDirection: 'row-reverse'
    }
  }, buttons, _react["default"].createElement(FilterColumnButton, {
    filters: filters,
    columns: visibleColumns,
    data: filteredData,
    filterValue: filterValue,
    filterMenuItem: filterMenuItem,
    onSetFilter: addFilter
  }), _react["default"].createElement(ToggleColumnButton, {
    columns: columns,
    toggledColumns: toggledColumns,
    onToggleColumnVisible: handleToggleColumnVisible
  }), options.csvExport && _react["default"].createElement(_core.Tooltip, {
    title: 'Save to CSV',
    placement: 'top'
  }, _react["default"].createElement(_reactCsv.CSVLink, {
    data: generateCsvData(),
    filename: options.csvFilename || title || 'table'
  }, _react["default"].createElement(_IconButton["default"], null, _react["default"].createElement(_Save["default"], null)))), _react["default"].createElement(_core.Tooltip, {
    title: 'Search',
    placement: 'top'
  }, _react["default"].createElement(_IconButton["default"], {
    onClick: handleToggleSearch
  }, _react["default"].createElement(_Search["default"], null))))), _react["default"].createElement(FiltersSummary, {
    filters: filters,
    onRemoveFilter: removeFilter,
    columns: columns
  })), _react["default"].createElement("div", {
    className: classes.tableContainer
  }, _react["default"].createElement(_Table["default"], {
    className: classes.table
  }, !options.loading && filteredData.length === 0 ? _react["default"].createElement(_TableRow["default"], null, _react["default"].createElement(_TableCell["default"], {
    style: {
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center'
    }
  }, typeof options.NoRowsCell === 'function' ? options.NoRowsCell() : _react["default"].createElement("div", {
    style: {
      margin: 32
    }
  }, "No data available"))) : _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_TableHead["default"], null, _react["default"].createElement(_TableRow["default"], null, !!visibleColumns && visibleColumns.map(function (column) {
    return _react["default"].createElement(_TableHeadButton["default"], {
      column: column,
      onSortColumn: sortColumn,
      sorts: sorts
    });
  }))), _react["default"].createElement(_TableBody["default"], null, options.loading ? new Array(rowsPerPage).fill(0).map(function (x, i) {
    return _react["default"].createElement(_TableRow["default"], {
      key: i
    }, visibleColumns.map(function (column) {
      return _react["default"].createElement(_TableCell["default"], {
        key: column.id,
        style: {
          padding: 14,
          borderWidth: i === rowsPerPage - pageData.length - 1 ? null : 0
        }
      }, _react["default"].createElement(_reactLoadingSkeleton["default"], {
        height: 20
      }));
    }));
  }) : !!pageData && pageData.map(function (row, itemIndex) {
    return _react["default"].createElement(_MUITableRow["default"], {
      key: itemIndex,
      row: row,
      options: options,
      colValue: colValue,
      onRowClick: handleOnRowClick,
      visibleColumns: visibleColumns
    });
  }), !options.loading && options.fillEmptyRows && emptyRows.map(function (x, i) {
    return _react["default"].createElement(_TableRow["default"], {
      key: i
    }, _react["default"].createElement(_TableCell["default"], {
      colSpan: '100%',
      style: {
        borderWidth: i === rowsPerPage - pageData.length - 1 ? null : 0
      }
    }, "\xA0"));
  })), options.footerRow && _react["default"].createElement(_core.TableFooter, null, _react["default"].createElement(_TableRow["default"], null, !!visibleColumns && visibleColumns.map(function (column, index) {
    return _react["default"].createElement(_MUITableFooterCell["default"], {
      key: "".concat(column.title, "-").concat(column.id),
      column: column,
      options: options,
      filteredData: filteredData,
      lastCol: index === visibleColumns.length - 1
    });
  })))))), _react["default"].createElement(_TablePagination["default"], {
    rowsPerPageOptions: [5, 10, 25],
    component: "div",
    count: filteredData.length,
    rowsPerPage: rowsPerPage,
    page: currentPage,
    backIconButtonProps: {
      'aria-label': 'previous page'
    },
    nextIconButtonProps: {
      'aria-label': 'next page'
    },
    onChangePage: function onChangePage(event, newPage) {
      return setCurrentPage(newPage);
    },
    onChangeRowsPerPage: function onChangeRowsPerPage(event) {
      return setRowsPerPage(event.target.value);
    }
  }));
}

function TitleSearchBar(_ref2) {
  var title = _ref2.title,
      showSearch = _ref2.showSearch,
      setShowSearch = _ref2.setShowSearch,
      searchFieldRef = _ref2.searchFieldRef,
      searchTerm = _ref2.searchTerm,
      addFilter = _ref2.addFilter;
  return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement("div", {
    style: {
      flex: showSearch ? 2 : 0,
      display: 'flex',
      overflow: 'hidden',
      transition: 'flex 0.2s ease-out'
    }
  }, _react["default"].createElement(_TextField["default"], {
    inputRef: searchFieldRef,
    style: {
      flex: 1
    },
    label: 'Search',
    value: searchTerm,
    onChange: function onChange(event) {
      return addFilter(event.target.value);
    }
  }), _react["default"].createElement(_IconButton["default"], {
    style: {
      flex: -1
    },
    onClick: function onClick() {
      return setShowSearch(false);
    },
    color: 'secondary'
  }, _react["default"].createElement(_Close["default"], null))), _react["default"].createElement(_core.Typography, {
    variant: 'h4',
    style: {
      flex: showSearch ? 0 : 2,
      overflow: 'hidden',
      transition: 'flex 0.2s ease-out'
    },
    noWrap: true
  }, title));
}

function ToggleColumnButton(_ref3) {
  var columns = _ref3.columns,
      toggledColumns = _ref3.toggledColumns,
      onToggleColumnVisible = _ref3.onToggleColumnVisible;

  var _React$useState = _react["default"].useState(null),
      _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
      anchorEl = _React$useState2[0],
      setAnchorEl = _React$useState2[1];

  function handleClick(event) {
    setAnchorEl(event.currentTarget);
  }

  function handleClose() {
    setAnchorEl(null);
  }

  return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_core.Tooltip, {
    title: 'Toggle Columns',
    placement: 'top'
  }, _react["default"].createElement(_IconButton["default"], {
    "aria-controls": "simple-menu",
    "aria-haspopup": "true",
    onClick: handleClick
  }, _react["default"].createElement(_ViewColumn["default"], null))), _react["default"].createElement(_Menu["default"], {
    id: "simple-menu",
    anchorEl: anchorEl,
    getContentAnchorEl: null,
    anchorOrigin: {
      vertical: 'bottom',
      horizontal: 'center'
    },
    transformOrigin: {
      vertical: 'top',
      horizontal: 'center'
    },
    open: Boolean(anchorEl),
    onClose: handleClose
  }, _react["default"].createElement(_FormControl["default"], {
    component: "fieldset",
    style: {
      margin: 16,
      minWidth: 200
    }
  }, _react["default"].createElement(_FormLabel["default"], {
    component: "legend"
  }, "Toggle Columns"), _react["default"].createElement(_FormGroup["default"], null, !!columns && columns.filter(function (column) {
    return !!column.hideable;
  }).map(function (column) {
    return _react["default"].createElement(_FormControlLabel["default"], {
      key: column.id,
      control: _react["default"].createElement(_Checkbox["default"], {
        checked: toggledColumns[column.id],
        onChange: function onChange() {
          return onToggleColumnVisible(column.id);
        }
      }),
      label: column.title
    });
  })))));
}

function FilterColumnButton(_ref4) {
  var filters = _ref4.filters,
      columns = _ref4.columns,
      data = _ref4.data,
      filterValue = _ref4.filterValue,
      filterMenuItem = _ref4.filterMenuItem,
      onSetFilter = _ref4.onSetFilter;

  var _React$useState3 = _react["default"].useState(null),
      _React$useState4 = (0, _slicedToArray2["default"])(_React$useState3, 2),
      anchorEl = _React$useState4[0],
      setAnchorEl = _React$useState4[1];

  function handleClick(event) {
    setAnchorEl(event.currentTarget);
  }

  function handleClose() {
    setAnchorEl(null);
  }

  var comparisonRef = (0, _react.useRef)();
  return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_core.Tooltip, {
    title: 'Filter',
    placement: 'top'
  }, _react["default"].createElement(_IconButton["default"], {
    "aria-controls": "simple-menu",
    "aria-haspopup": "true",
    onClick: handleClick
  }, _react["default"].createElement(_FilterList["default"], null))), _react["default"].createElement(_Menu["default"], {
    id: "simple-menu",
    anchorEl: anchorEl,
    getContentAnchorEl: null,
    anchorOrigin: {
      vertical: 'bottom',
      horizontal: 'center'
    },
    transformOrigin: {
      vertical: 'top',
      horizontal: 'center'
    },
    open: Boolean(anchorEl),
    onClose: handleClose
  }, _react["default"].createElement("div", {
    style: {
      margin: 16,
      minWidth: 200,
      maxWidth: 500
    }
  }, _react["default"].createElement(_Grid["default"], {
    container: true,
    spacing: 2
  }, !!columns && columns.filter(function (column) {
    return !!column.filterable;
  }).map(function (column) {
    return _react["default"].createElement(_Grid["default"], {
      key: column.id,
      item: true,
      xs: 12,
      md: 6
    }, column.filterType === 'text' ? _react["default"].createElement(TextFilter, {
      filters: filters,
      column: column,
      onSetFilter: onSetFilter
    }) : column.filterType === 'numeric' ? _react["default"].createElement(NumericFilter, {
      filters: filters,
      column: column,
      onSetFilter: onSetFilter
    }) : _react["default"].createElement(SelectFilter, {
      filters: filters,
      on: true,
      onSetFilter: onSetFilter,
      column: column,
      data: data,
      filterValue: filterValue,
      filterMenuItem: filterMenuItem
    }));
  })))));
}

function TextFilter(_ref5) {
  var filters = _ref5.filters,
      column = _ref5.column,
      onSetFilter = _ref5.onSetFilter;
  return _react["default"].createElement(_FormControl["default"], {
    fullWidth: true
  }, _react["default"].createElement(_TextField["default"], {
    label: column.title,
    value: (filters.find(function (x) {
      return x.columnId === column.id;
    }) || {}).value || '',
    onChange: function onChange(event) {
      return onSetFilter(event.target.value, column.id, 'default');
    }
  }));
}

var operators = {
  lt: '<',
  lte: '≤',
  eq: '=',
  gt: '>',
  gte: '≥'
};

function NumericFilter(_ref6) {
  var filters = _ref6.filters,
      column = _ref6.column,
      onSetFilter = _ref6.onSetFilter;

  var _useState15 = (0, _react.useState)((filters.find(function (x) {
    return x.columnId === column.id;
  }) || {}).type || 'eq'),
      _useState16 = (0, _slicedToArray2["default"])(_useState15, 2),
      comparison = _useState16[0],
      setComparison = _useState16[1];

  var _useState17 = (0, _react.useState)((filters.find(function (x) {
    return x.columnId === column.id;
  }) || {}).value || ''),
      _useState18 = (0, _slicedToArray2["default"])(_useState17, 2),
      value = _useState18[0],
      setValue = _useState18[1];

  (0, _react.useEffect)(function () {
    onSetFilter(value, column.id, comparison);
  }, [value, column.id, comparison]);
  return _react["default"].createElement("div", {
    style: {
      display: 'flex'
    }
  }, _react["default"].createElement(_FormControl["default"], {
    style: {
      flex: 1
    }
  }, _react["default"].createElement(_TextField["default"], {
    type: "number",
    label: column.title,
    value: value,
    onChange: function onChange(event) {
      return setValue(event.target.value);
    },
    InputProps: {
      startAdornment: _react["default"].createElement(_InputAdornment["default"], {
        position: "start"
      }, _react["default"].createElement(_core.Select, {
        style: {
          flex: -1
        },
        value: comparison,
        onChange: function onChange(event) {
          return setComparison(event.target.value);
        },
        disableUnderline: true
      }, Object.keys(operators).map(function (key) {
        return _react["default"].createElement(_MenuItem["default"], {
          value: key
        }, operators[key]);
      })))
    }
  })));
}

function SelectFilter(_ref7) {
  var filters = _ref7.filters,
      onSetFilter = _ref7.onSetFilter,
      column = _ref7.column,
      data = _ref7.data,
      filterValue = _ref7.filterValue,
      filterMenuItem = _ref7.filterMenuItem;
  var rowSet = data.reduce(function (acc, row) {
    var value = filterValue(row, column.id);
    acc[value] = row;
    return acc;
  }, {});
  return _react["default"].createElement(_FormControl["default"], {
    fullWidth: true
  }, _react["default"].createElement(_InputLabel["default"], null, column.title), _react["default"].createElement(_core.Select, {
    value: (filters.find(function (x) {
      return x.columnId === column.id;
    }) || {}).value || '',
    onChange: function onChange(event) {
      return onSetFilter(event.target.value, column.id, 'exact');
    }
  }, _react["default"].createElement(_MenuItem["default"], {
    value: ''
  }, "All"), Object.keys(rowSet).map(function (value) {
    return _react["default"].createElement(_MenuItem["default"], {
      key: value,
      value: value
    }, filterMenuItem(rowSet[value], column.id));
  })));
}

var FiltersSummary = function FiltersSummary(_ref8) {
  var filters = _ref8.filters,
      columns = _ref8.columns,
      onRemoveFilter = _ref8.onRemoveFilter;
  return _react["default"].createElement(_core.Collapse, {
    "in": !!filters && filters.length > 0
  }, _react["default"].createElement("div", {
    style: {
      display: 'flex'
    }
  }, _react["default"].createElement(_core.Typography, {
    style: {
      marginRight: 16
    }
  }, "Filters:"), _react["default"].createElement("div", {
    style: {
      display: 'flex',
      margin: -4
    }
  }, filters.map(function (filter, filterId) {
    var filterLabel = "".concat(filter.columnId === -1 ? '' : "".concat(columns.find(function (x) {
      return x.id === filter.columnId;
    }).title, ": ")).concat(operators[filter.type] || '').concat(filter.value);
    return _react["default"].createElement(_Chip["default"], {
      key: filterId,
      style: {
        margin: 4
      },
      label: filterLabel,
      onDelete: function onDelete() {
        return onRemoveFilter(filterId);
      }
    });
  }))));
};