"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = MUITableCell;

var _react = _interopRequireDefault(require("react"));

var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));

var _core = require("@material-ui/core");

var _classnames = _interopRequireDefault(require("classnames"));

var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    tableCellNoWrap: {
      whiteSpace: 'nowrap'
    },
    tableCellPadding: function tableCellPadding(_ref) {
      var column = _ref.column,
          options = _ref.options,
          lastCol = _ref.lastCol;
      return {
        padding: "".concat(column.padding.top, "px ").concat(lastCol ? 16 : column.padding.right, "px ").concat(column.padding.bottom, "px ").concat(column.padding.left, "px"),
        maxHeight: options.maxRowHeight ? options.maxRowHeight - column.padding.top - column.padding.bottom : null,
        overflow: 'hidden',
        minWidth: column.minWidth
      };
    }
  };
});

function MUITableCell(_ref2) {
  var column = _ref2.column,
      colValue = _ref2.colValue,
      row = _ref2.row,
      options = _ref2.options,
      lastCol = _ref2.lastCol;
  var classes = useStyles({
    column: column,
    options: options,
    lastCol: lastCol
  });
  return _react["default"].createElement(_TableCell["default"], {
    align: column.align,
    className: (0, _classnames["default"])(column.noWrap && classes.tableCellNoWrap),
    style: {
      padding: 0
    }
  }, _react["default"].createElement("div", {
    className: (0, _classnames["default"])(classes.tableCellPadding)
  }, colValue(row, column.id)));
}