"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = MUITableFooterCell;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));

var _core = require("@material-ui/core");

var _classnames = _interopRequireDefault(require("classnames"));

var _reactLoadingSkeleton = _interopRequireDefault(require("react-loading-skeleton"));

var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    tableCellNoWrap: {
      whiteSpace: 'nowrap'
    },
    tableCellPadding: function tableCellPadding(_ref) {
      var column = _ref.column,
          lastCol = _ref.lastCol;
      return {
        padding: "".concat(column.padding.top, "px ").concat(lastCol ? 16 : column.padding.right, "px ").concat(column.padding.bottom, "px ").concat(column.padding.left, "px"),
        overflow: 'hidden',
        minWidth: column.minWidth,
        width: column.shrink ? 1 : null
      };
    }
  };
});

function MUITableFooterCell(_ref2) {
  var column = _ref2.column,
      options = _ref2.options,
      filteredData = _ref2.filteredData,
      lastCol = _ref2.lastCol;
  var classes = useStyles({
    column: column,
    lastCol: lastCol
  });
  return _react["default"].createElement(_TableCell["default"], (0, _extends2["default"])({}, column.props, {
    className: (0, _classnames["default"])(column.noWrap && classes.tableCellNoWrap),
    align: column.align,
    style: {
      padding: 0
    }
  }), options.loading ? _react["default"].createElement("div", {
    style: {
      padding: 14
    }
  }, _react["default"].createElement(_reactLoadingSkeleton["default"], {
    height: 21
  })) : _react["default"].createElement("div", {
    className: (0, _classnames["default"])(classes.tableCellPadding)
  }, typeof column.Footer === 'function' ? column.Footer(filteredData, column) : _react["default"].createElement(_react["default"].Fragment, null)));
}