"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = MUITableRow;

var _react = _interopRequireDefault(require("react"));

var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));

var _TableRow = _interopRequireDefault(require("@material-ui/core/TableRow"));

var _core = require("@material-ui/core");

var _classnames = _interopRequireDefault(require("classnames"));

var _MUITableCell = _interopRequireDefault(require("./MUITableCell"));

var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    tableRowClick: {
      '&:hover': {
        cursor: 'pointer',
        backgroundColor: '#eaeaea'
      },
      '&:active': {
        backgroundColor: '#dadada'
      }
    },
    tableRowSelected: {
      backgroundColor: '#dadada'
    }
  };
});

function MUITableRow(_ref) {
  var row = _ref.row,
      onRowClick = _ref.onRowClick,
      visibleColumns = _ref.visibleColumns,
      colValue = _ref.colValue,
      options = _ref.options;
  var classes = useStyles();
  var clickable = typeof options.onRowClick === 'function';
  var selected = !!options.selectedRowId && row.id === options.selectedRowId;
  return _react["default"].createElement(_TableRow["default"], {
    className: (0, _classnames["default"])(clickable && classes.tableRowClick, selected && classes.tableRowSelected),
    onClick: function onClick(event) {
      return onRowClick(event, row);
    }
  }, !!visibleColumns && visibleColumns.map(function (column, index) {
    return _react["default"].createElement(_MUITableCell["default"], {
      key: column.id,
      colValue: colValue,
      column: column,
      options: options,
      row: row,
      lastCol: index === visibleColumns.length - 1
    });
  }));
}