"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = TableHeadButton;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _core = require("@material-ui/core");

var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));

var _ButtonBase = _interopRequireDefault(require("@material-ui/core/ButtonBase"));

var _react = _interopRequireDefault(require("react"));

var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    sortIndicatorAsc: {
      position: 'absolute',
      backgroundColor: '#3498db',
      top: 0,
      left: 0,
      right: 0,
      height: 2
    },
    sortIndicatorDesc: {
      position: 'absolute',
      backgroundColor: '#3498db',
      bottom: 0,
      left: 0,
      right: 0,
      height: 2
    },
    tableHeaderCell: function tableHeaderCell(_ref) {
      var column = _ref.column;
      return {
        width: column.shrink ? '1%' : null,
        position: 'relative',
        padding: 0,
        whiteSpace: 'nowrap',
        '&:last-child': {
          paddingRight: 0,
          '& button': {
            paddingRight: 16
          }
        }
      };
    },
    tableHeaderButton: function tableHeaderButton(_ref2) {
      var column = _ref2.column;
      return {
        display: 'table-cell',
        width: '100%',
        padding: '14px 40px 14px 16px',
        textAlign: column.align || 'left',
        '&:hover': {
          backgroundColor: '#f5f5f5'
        }
      };
    }
  };
});

function TableHeadButton(_ref3) {
  var column = _ref3.column,
      sorts = _ref3.sorts,
      onSortColumn = _ref3.onSortColumn;
  var classes = useStyles({
    column: column
  });
  var columnSort = sorts.find(function (x) {
    return x.columnId === column.id;
  });
  var sortClass = columnSort ? columnSort.direction === 'asc' ? classes.sortIndicatorAsc : classes.sortIndicatorDesc : null;
  return _react["default"].createElement(_TableCell["default"], (0, _extends2["default"])({
    key: column.id
  }, column.props, {
    className: classes.tableHeaderCell
  }), _react["default"].createElement(_ButtonBase["default"], {
    className: classes.tableHeaderButton,
    disabled: !column.sortable,
    onClick: function onClick(event) {
      return onSortColumn(event, column.id);
    }
  }, _react["default"].createElement("span", null, column.title || _react["default"].createElement("span", null, "\xA0")), _react["default"].createElement("div", {
    className: sortClass
  })));
}